// SocketSwitch.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "SocketSwitch.h"
#include "Winsock2.h"
#include "stdio.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

typedef struct _SendRec
{
  SOCKET  sReceive;
  int     nReceivePort;
  char    *szReceiveAddr;
  SOCKET  sSend;
  int     nSendPort;
  char    *szSendAddr;
} SendRec;

static int          gboListen = false;
static int          gboConnect;
static int          gnSockTypeIn = SOCK_STREAM;
static int          gnPortIn = 23;
static int          gnSockTypeOut = SOCK_STREAM;
static int          gnPortOut = 23;
static char         gszAddressOut[1024] = "127.0.0.1";
static char         gszAddressIn[1024] = "127.0.0.1";
static HANDLE       ghListenHandle = 0;
static HWND         ghWnd = 0;
static WSAData      gsWSAData;
static bool         gboClosed;
static SendRec      gsSendRecIn;
static SendRec      gsSendRecOut;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	Details(HWND, UINT, WPARAM, LPARAM);
void listenProc(void);
void Quit (void);
void Connect (bool boConnect);
void SetMenuTick (HWND hWnd, UINT uMenuID, bool boTick);
void SendRecProc (SendRec * psSendRec);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SOCKETSWITCH, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

  gboListen = false;
  gboConnect = false;

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SOCKETSWITCH);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_SOCKETSWITCH);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_SOCKETSWITCH;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
  HWND hWnd;

  hInst = hInstance; // Store instance handle in our global variable

  hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT, 0, 180, 100, NULL, NULL, hInstance, NULL);

  if (!hWnd)
  {
    return FALSE;
  }

  ghWnd = hWnd;
  if (WSAStartup (MAKEWORD (1, 1), & gsWSAData) != 0)
  {
  	MessageBox (ghWnd, "Error starting WinSock", "Socket error", MB_OK);
	  return 0;
  }

  Connect (gboConnect);

  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);

  return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox (hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			Quit ();
			break;
	  case ID_CONNECT_CONNECT:
	    Connect (!gboConnect);
	    break;
	  case IDM_DETAILS:
			DialogBox (hInst, (LPCTSTR)IDD_DETAILS, hWnd, (DLGPROC)Details);
	    break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

// Message handler for details box.
LRESULT CALLBACK Details(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  char szText[1024];
	HWND hCombo;
	HWND hItem;
  int nSel;

	switch (message)
	{
	case WM_INITDIALOG:
    SetDlgItemText (hDlg, IDC_SENDIP, gszAddressOut);
    sprintf (szText, "%d", gnPortOut);
    SetDlgItemText (hDlg, IDC_SENDPORT, szText);
		hCombo = GetDlgItem (hDlg, IDC_SENDTYPE);
    sprintf (szText, "TCP");
		SendMessage (hCombo, (UINT)CB_ADDSTRING, 0, (LPARAM)szText);
    sprintf (szText, "UDP");
		SendMessage (hCombo, (UINT)CB_ADDSTRING, 0, (LPARAM)szText);
		SendMessage (hCombo, (UINT)CB_SETCURSEL, (WPARAM)(gnSockTypeOut - 1), 0);


    SetDlgItemText (hDlg, IDC_RECEIVEIP, gszAddressIn);
    sprintf (szText, "%d", gnPortIn);
    SetDlgItemText (hDlg, IDC_RECEIVEPORT, szText);
		hCombo = GetDlgItem (hDlg, IDC_RECEIVETYPE);
    sprintf (szText, "TCP");
		SendMessage (hCombo, (UINT)CB_ADDSTRING, 0, (LPARAM)szText);
    sprintf (szText, "UDP");
		SendMessage (hCombo, (UINT)CB_ADDSTRING, 0, (LPARAM)szText);
		SendMessage (hCombo, (UINT)CB_SETCURSEL, (WPARAM)(gnSockTypeIn - 1), 0);
    hItem = GetDlgItem (hDlg, IDC_RECEIVEIP);
    EnableWindow (hItem, (gnSockTypeIn == 2));
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK)
		{
		  GetDlgItemText (hDlg, IDC_SENDIP, gszAddressOut, sizeof (gszAddressOut));
		  GetDlgItemText (hDlg, IDC_SENDPORT, szText, sizeof (szText));
		  sscanf (szText, "%d", & gnPortOut);
  		hCombo = GetDlgItem (hDlg, IDC_SENDTYPE);
  		gnSockTypeOut = SendMessage (hCombo, (UINT)CB_GETCURSEL, 0, (LPARAM)0) + 1;

		  GetDlgItemText (hDlg, IDC_RECEIVEIP, gszAddressIn, sizeof (gszAddressIn));
		  GetDlgItemText (hDlg, IDC_RECEIVEPORT, szText, sizeof (szText));
		  sscanf (szText, "%d", & gnPortIn);
  		hCombo = GetDlgItem (hDlg, IDC_RECEIVETYPE);
  		gnSockTypeIn = SendMessage (hCombo, (UINT)CB_GETCURSEL, 0, (LPARAM)0) + 1;
		}

		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}

    if (HIWORD(wParam) == CBN_SELCHANGE)
    {
  		hCombo = GetDlgItem (hDlg, IDC_RECEIVETYPE);
  		nSel = SendMessage (hCombo, (UINT)CB_GETCURSEL, 0, (LPARAM)0) + 1;

      hItem = GetDlgItem (hDlg, IDC_RECEIVEIP);
      EnableWindow (hItem, (nSel == 2));
		  return TRUE;
    }
		break;
	}
	return FALSE;
}

void Quit (void)
{
	WSACleanup();
}

void listenProc(void)
{
	SOCKET              nSockfdIn;
	SOCKET              nSockfdOut;
	struct sockaddr_in  sHostAddr;
	struct sockaddr_in  sClientAddr;
	int                 nReturn;
	int                 nSize;
	SOCKET              nAcceptfd = NULL;
	fd_set              sListenSet;
	timeval             sTime;
  int                 nMemSize = 1024*10;
  char                szError[1024];
  HANDLE              hHandleIn;
  HANDLE              hHandleOut;
  bool                boAccept;
  bool                boOpt = TRUE;

	if (gboListen != true)
  {
    return;
  }

  nSockfdIn = socket (AF_INET, gnSockTypeIn, 0);
	if (nSockfdIn == INVALID_SOCKET)
	{
	  sprintf (szError, "Error creating socket in (%d)", WSAGetLastError ());
  	MessageBox (ghWnd, szError, "Socket error", MB_OK);
	  return;
	}
  setsockopt (nSockfdIn, SOL_SOCKET, SO_REUSEADDR, (char *)(& boOpt), sizeof (bool));


  nSockfdOut = socket (AF_INET, gnSockTypeOut, 0);
	if (nSockfdOut == INVALID_SOCKET)
	{
	  sprintf (szError, "Error creating socket out (%d)", WSAGetLastError ());
  	MessageBox (ghWnd, szError, "Socket error", MB_OK);
	  shutdown (nSockfdIn, SD_BOTH);
	  closesocket (nSockfdIn);
    gboListen = false;
    gboConnect = false;
    SetMenuTick (ghWnd, ID_CONNECT_CONNECT, gboListen);
	  return;
	}
  setsockopt (nSockfdOut, SOL_SOCKET, SO_REUSEADDR, (char *)(& boOpt), sizeof (bool));

	sHostAddr.sin_family = AF_INET;
	sHostAddr.sin_port = htons (gnPortIn);
  sHostAddr.sin_addr.s_addr = htonl (INADDR_ANY);
	memset (& (sHostAddr.sin_zero), '\0', 8);

	nReturn = bind (nSockfdIn, (struct sockaddr *)& sHostAddr, sizeof (struct sockaddr));
  if (nReturn != 0)
  {
	  sprintf (szError, "Error binding socket in (%d)", WSAGetLastError ());
  	MessageBox (ghWnd, szError, "Socket error", MB_OK);
	  shutdown (nSockfdOut, SD_BOTH);
	  closesocket (nSockfdOut);
	  shutdown (nSockfdIn, SD_BOTH);
	  closesocket (nSockfdIn);
    gboListen = false;
    gboConnect = false;
    SetMenuTick (ghWnd, ID_CONNECT_CONNECT, gboListen);
    return;
  }

  if (gnSockTypeIn == SOCK_STREAM)
  {
	  nReturn = listen (nSockfdIn, 10);
    if (nReturn != 0)
    {
	    sprintf (szError, "Error listening on socket in (%d)", WSAGetLastError ());
  	  MessageBox (ghWnd, szError, "Socket error", MB_OK);
	    shutdown (nSockfdOut, SD_BOTH);
	    closesocket (nSockfdOut);
	    shutdown (nSockfdIn, SD_BOTH);
	    closesocket (nSockfdIn);
      gboListen = false;
      gboConnect = false;
      SetMenuTick (ghWnd, ID_CONNECT_CONNECT, gboListen);
      return;
    }
  }

	while ((gboListen) && (gboConnect))
	{
	  if (gnSockTypeIn == SOCK_STREAM)
	  {
  	  boAccept = false;
		  FD_ZERO (& sListenSet);
		  FD_SET (nSockfdIn, & sListenSet);
		  sTime.tv_sec = 0;
		  sTime.tv_usec = 100000;
		  nReturn = select ((int)nSockfdIn + 1, & sListenSet, NULL, NULL, & sTime);
		  if (nReturn != -1)
		  {
			  if (FD_ISSET (nSockfdIn, & sListenSet))
			  {
				  // Need to forward any data received
				  nSize = sizeof (struct sockaddr_in);
				  nAcceptfd = accept (nSockfdIn, (struct sockaddr *)& sClientAddr, & nSize);
          boAccept = true;
        }
      }
		  else
		  {
	      sprintf (szError, "Error selecting socket in (%d)", WSAGetLastError ());
  	    MessageBox (ghWnd, szError, "Socket error", MB_OK);
        gboListen = false;
		  }
    }
		else
		{
  	  shutdown (nSockfdIn, SD_BOTH);
  	  closesocket (nSockfdIn);
      nSockfdIn = INVALID_SOCKET;

      nAcceptfd = socket (AF_INET, gnSockTypeIn, 0);
	    if (nAcceptfd == INVALID_SOCKET)
	    {
	      sprintf (szError, "Error creating socket in (%d)", WSAGetLastError ());
  	    MessageBox (ghWnd, szError, "Socket error", MB_OK);
	      return;
	    }
      setsockopt (nAcceptfd, SOL_SOCKET, SO_REUSEADDR, (char *)(& boOpt), sizeof (bool));

	    sHostAddr.sin_family = AF_INET;
	    sHostAddr.sin_port = htons (gnPortIn);
	    sHostAddr.sin_addr.s_addr = htonl (INADDR_ANY);//inet_addr (gszAddressIn);
	    memset (& (sHostAddr.sin_zero), '\0', 8);

      nReturn = bind (nAcceptfd, (struct sockaddr *)& sHostAddr, sizeof (struct sockaddr));

      if (nReturn != 0)
      {
	      sprintf (szError, "Error connecting to socket in (%d)", WSAGetLastError ());
  	    MessageBox (ghWnd, szError, "Socket error", MB_OK);
	      shutdown (nSockfdOut, SD_BOTH);
	      closesocket (nSockfdOut);
	      shutdown (nSockfdIn, SD_BOTH);
	      closesocket (nSockfdIn);
        gboListen = false;
        return;
      }

      boAccept = true;
    }

    if (boAccept)
    {
	    sHostAddr.sin_family = AF_INET;
	    sHostAddr.sin_port = htons (gnPortOut);
      if (gnSockTypeOut == SOCK_STREAM)
      {
	      sHostAddr.sin_addr.s_addr = inet_addr (gszAddressOut);
	      memset (& (sHostAddr.sin_zero), '\0', 8);
        nReturn = connect (nSockfdOut, (struct sockaddr *)& sHostAddr, sizeof (struct sockaddr));
      }
      else
      {
	      sHostAddr.sin_addr.s_addr = htonl (INADDR_ANY);//inet_addr (gszAddressOut);
	      memset (& (sHostAddr.sin_zero), '\0', 8);
        nReturn = bind (nSockfdOut, (struct sockaddr *)& sHostAddr, sizeof (struct sockaddr));
      }

      if (nReturn != 0)
      {
	      sprintf (szError, "Error connecting to socket out (%d)", WSAGetLastError ());
  	    MessageBox (ghWnd, szError, "Socket error", MB_OK);
	      shutdown (nSockfdOut, SD_BOTH);
	      closesocket (nSockfdOut);
	      shutdown (nSockfdIn, SD_BOTH);
	      closesocket (nSockfdIn);
        gboListen = false;
        return;
      }




      gboClosed = false;

      gsSendRecIn.sReceive = nAcceptfd;
      gsSendRecIn.szReceiveAddr = gszAddressIn;
      gsSendRecIn.nReceivePort = gnPortIn;
      gsSendRecIn.sSend = nSockfdOut;
      gsSendRecIn.szSendAddr = gszAddressOut;
      gsSendRecIn.nSendPort = gnPortOut;

      hHandleIn = CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) SendRecProc, (void*)(& gsSendRecIn), 0, NULL);

      gsSendRecOut.sReceive = nSockfdOut;
      gsSendRecOut.szReceiveAddr = gszAddressOut;
      gsSendRecOut.nReceivePort = gnPortOut;
      gsSendRecOut.sSend = nAcceptfd;
      gsSendRecOut.szSendAddr = gszAddressIn;
      gsSendRecOut.nSendPort = gnPortIn;

      hHandleOut = CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) SendRecProc, (void*)(& gsSendRecOut), 0, NULL);

      gboListen = false;
		}
	}

	shutdown (nSockfdIn, SD_BOTH);
	closesocket (nSockfdIn);
  gboListen = false;
}

void Connect (bool boConnect)
{
  if ((boConnect) && (!gboListen))
  {
    gboListen = true;
    ghListenHandle = CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) listenProc, 0, 0, NULL);
  }

  gboConnect = boConnect;
  SetMenuTick (ghWnd, ID_CONNECT_CONNECT, gboConnect);
}

void SetMenuTick (HWND hWnd, UINT uMenuID, bool boTick)
{
  HMENU hMenu;
  MENUITEMINFO sMenuItem;

  hMenu = GetMenu (hWnd);
  sMenuItem.cbSize = sizeof (MENUITEMINFO);

  sMenuItem.fMask = MIIM_STATE;
//      GetMenuItemInfo (hMenu, uMenuID, FALSE, & sMenuItem);
  if (boTick)
  {
    sMenuItem.fState = MFS_CHECKED;
  }
  else
  {
    sMenuItem.fState = MFS_UNCHECKED;
  }
  SetMenuItemInfo (hMenu, uMenuID, FALSE, & sMenuItem);
}

void SendRecProc (SendRec * psSendRec)
{
	int                 nStorePos;
  int                 nMemSize = 1024*10;
  char                pcMemory[1024*10];
  char                szError[1024];
  int                 nShiftPos;
  int                 boClosed;
  SendRec             sSendRec;
  int                 nReturn;
  int                 nError;
	struct sockaddr_in  sReceiveAddr;
	struct sockaddr_in  sSendAddr;
	int                 nLen;

  sSendRec = * psSendRec;

	sReceiveAddr.sin_family = AF_INET;
	sReceiveAddr.sin_port = htons (sSendRec.nReceivePort);
	sReceiveAddr.sin_addr.s_addr = inet_addr (sSendRec.szReceiveAddr);
	memset (& (sReceiveAddr.sin_zero), '\0', 8);

	sSendAddr.sin_family = AF_INET;
	sSendAddr.sin_port = htons (sSendRec.nSendPort);
	sSendAddr.sin_addr.s_addr = inet_addr (sSendRec.szSendAddr);
	memset (& (sSendAddr.sin_zero), '\0', 8);

	nStorePos = 0;

  boClosed = false;
	do
	{
    // In
		if ((nMemSize - nStorePos) > 0)
		{
			// Receive some data
      nLen = sizeof (sockaddr);
  		nReturn = recvfrom (sSendRec.sReceive, (pcMemory + nStorePos), (nMemSize - nStorePos), 0, (sockaddr *)& sReceiveAddr, & nLen);
			if (nReturn < 0)
			{
			  nError = WSAGetLastError ();
			  if (nError != WSAEMSGSIZE)
			  {
 	        sprintf (szError, "Error receiving on socket in (%d)", nError);
  	      MessageBox (NULL, szError, "Socket error", MB_OK);
  	      nReturn = 0;
  	    }
			}
			if (nReturn == 0)
			{
  			boClosed = true;
			}
			if (nReturn > 0)
			{
				nStorePos += nReturn;
			}
  	}
  	
    while ((nStorePos > 0) && (nReturn > 0))
    {
			// Send some data
      nLen = sizeof (sockaddr);
			nReturn = sendto (sSendRec.sSend, pcMemory, nStorePos, 0, (sockaddr *)& sSendAddr, nLen);
			
			if (nReturn < 0)
			{
			  nError = WSAGetLastError ();
			  if (nError != WSAEMSGSIZE)
			  {
	        sprintf (szError, "Error sending on socket out (%d)", WSAGetLastError ());
  	      MessageBox (NULL, szError, "Socket error", MB_OK);
  	      nReturn = 0;
  	    }
			}
			if (nReturn > 0)
			{
				// Shift data down
        for (nShiftPos = nReturn; nShiftPos < nStorePos; nShiftPos++)
        {
          pcMemory[nShiftPos - nReturn] = pcMemory[nShiftPos];
        }
				nStorePos -= nReturn;
			}
    }
	} while ((!boClosed) && (!gboClosed));

  gboClosed = true;
	shutdown (sSendRec.sReceive, SD_BOTH);
	closesocket (sSendRec.sReceive);
	shutdown (sSendRec.sSend, SD_BOTH);
	closesocket (sSendRec.sSend);

  Connect (gboConnect);
}
